<?php

namespace Strig\Category;

use Ep\Cache\AbstractCacheFactory;

return [
    'dependencies' => [
        'aliases' => [
            Adapter\CategoryAdapterInterface::class => Adapter\WordpressCategoryAdapter::class,
//            Adapter\CategoryAdapterInterface::class => Adapter\GathCategoryAdapter::class,
            CategoryUrlGeneratorInterface::class => CategoryUrlGenerator::class,
        ],

        'invokables' => [
            Handler\HomePageHandler::class,
            CategoryUrlGenerator::class,
        ],
        'factories' => [
            CategoryMiddleware::class => CategoryMiddlewareFactory::class,
            CategoryManager::class => CategoryManagerFactory::class,

            \Zend\Expressive\MiddlewareContainer::class => \Zend\Expressive\Container\MiddlewareContainerFactory::class,

            Middleware\CategoryByParentMiddleware::class => Middleware\CategoryByParentMiddlewareFactory::class,
            Middleware\CategoryImagesMiddleware::class => Middleware\CategoryImagesMiddlewareFactory::class,
            Middleware\CategorySpritesMiddleware::class => Middleware\CategorySpritesMiddlewareFactory::class,

            Adapter\GathCategoryAdapter::class => Adapter\GathCategoryAdapterFactory::class,
            Adapter\WordpressCategoryAdapter::class => Adapter\WordpressCategoryAdapterFactory::class,

            Handler\CategoryHandler::class => Handler\CategoryHandlerFactory::class,
            Repository\RepositoryPluginManager::class => Repository\RepositoryPluginManagerFactory::class,

            'redis_cache' => AbstractCacheFactory::class
        ]
    ]
];
