<?php

namespace Strig\Category\Adapter;

use Psr\Container\ContainerInterface;
use Strig\Category\CategoryUrlGeneratorInterface;
use Zend\Db\Adapter\AdapterInterface;
use Zend\ServiceManager\Exception\ServiceNotCreatedException;
use Zend\ServiceManager\Exception\ServiceNotFoundException;

class WordpressCategoryAdapterFactory
{

    /**
     * Create an object
     *
     * @param  ContainerInterface $container
     * @param string $requestedName
     * @param array|null $options
     * @throws ServiceNotFoundException if unable to resolve the service.
     * @throws ServiceNotCreatedException if an exception is raised when
     *     creating a service.
     * @return object
     */
    public function __invoke(ContainerInterface $container, string $requestedName, array $options = null)
    {
        return new WordpressCategoryAdapter(
            $container->get(AdapterInterface::class),
            $container->get('config')['sprites'],
            $container->get(CategoryUrlGeneratorInterface::class)
        );
    }
}
