<?php

namespace Strig\Category\Handler;

use Psr\Container\ContainerInterface;
use Strig\Category\CategoryManager;
use Strig\Category\Entity\Category;
use Strig\Category\Repository\CategoryRepository;
use Zend\ServiceManager\Exception\ServiceNotCreatedException;
use Zend\ServiceManager\Exception\ServiceNotFoundException;

class CategoryHandlerFactory
{
    /**
     * @param ContainerInterface $container
     * @param string $requestedName
     * @param array|null $options
     * @throws ServiceNotFoundException if unable to resolve the service.
     * @throws ServiceNotCreatedException if an exception is raised when
     *      creating a service.
     * @return CategoryHandler
     */
    public function __invoke(ContainerInterface $container, string $requestedName, array $options = null)
    {
        /** @var CategoryManager $manager */
        $manager = $container->get(CategoryManager::class);

        /** @var CategoryRepository $repository */
        $repository = $manager->getRepository(Category::class);


        return new CategoryHandler($repository);
    }
}
