<?php

namespace Strig\Category\Middleware;

use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Psr\Http\Server\MiddlewareInterface;
use Psr\Http\Server\RequestHandlerInterface;
use Strig\Category\Repository\CategoryRepository;
use Zend\Diactoros\Response\JsonResponse;

class CategoryByParentMiddleware implements MiddlewareInterface
{

    protected $repository;

    public function __construct(CategoryRepository $categoryRepository)
    {
        $this->repository = $categoryRepository;
    }


    /**
     * Process an incoming server request and return a response, optionally delegating
     * response creation to a handler.
     * @param ServerRequestInterface $request
     * @param RequestHandlerInterface $handler
     * @return ResponseInterface
     */
    public function process(ServerRequestInterface $request, RequestHandlerInterface $handler): ResponseInterface
    {
        $uri = $request->getUri();
        $path = substr($uri->getPath(), 1);

        $pieces = explode('/', $path);

        $parent = $pieces[0];

//        $parent = $request->getAttribute('id');

        $data = $this->repository->getByParent($parent);

        return new JsonResponse($data);
    }
}
