<?php

namespace Strig\Category\Repository;

use Psr\Container\ContainerInterface;
use Strig\Category\Adapter\CategoryAdapterInterface;
use Zend\ServiceManager\Exception\ServiceNotCreatedException;
use Zend\ServiceManager\Exception\ServiceNotFoundException;

class CategoryRepositoryFactory
{
    /**
     * Create an object
     *
     * @param  ContainerInterface $container
     * @param  string $requestedName
     * @param  null|array $options
     * @return object
     * @throws ServiceNotFoundException if unable to resolve the service.
     * @throws ServiceNotCreatedException if an exception is raised when
     *     creating a service.
     */
    public function __invoke(ContainerInterface $container, string $requestedName, array $options = null)
    {

        return new CategoryRepository(
            $container->get(CategoryAdapterInterface::class),
            $container->get('redis_cache')
        );
    }
}
